function PrinterService(OperatorRepository, PrinterPoynt, PrinterCieloLio, PrinterGertec, PrinterGetnet, WindowService, PrinterPagSeguro, PrinterElgin, PrinterADX8000, PrinterStone, PrinterSmartA8, PrinterPositivo, PrinterGPOS720) {

	var self = this;

	var PrinterClass = null;
	var PRINTER_TYPE = {
		'25': PrinterGertec,
		'26': PrinterPoynt,
		'27': PrinterCieloLio,
		'38': PrinterGetnet,
		'39': PrinterPagSeguro,
		'40': PrinterStone,
		'47': PrinterElgin,
		'48': PrinterADX8000,
		'49': PrinterSmartA8,
		'50': PrinterPositivo,
		'51': PrinterGPOS720
	};

	var COMMANDS_NOT_FOUND = 'Comandos de impressora não foram adicionados.';
	var NO_PARAMETERIZED_PRINTER = 'Impressora não parametrizada ou inválida para o tipo de Caixa.';
	var PRINT_ERROR = 'Falha na impressão. ';

	this.TEXT_COMMAND = 'printText';
	this.QRCODE_COMMAND = 'printQRCode';
	this.BARCODE_COMMAND = 'printBarCode';
	this.DELAY_COMMAND = 'printerDelay';
	this.PRINT_COMMAND = 'print';
	this.ABRE_PORTA = 'abrePorta';
	this.CORTAR_CUPOM = 'corteParcial';

	this.printerCommands = Array();

	this.printerCommand = function(type, parameter){
		if (_.isString(parameter) && !_.isEmpty(parameter)){
			var boComandoIgual = false;
			/*var pos = self.printerCommands.length-1;
			if(self.printerCommands[pos] && self.TEXT_COMMAND == type ){
				if( self.printerCommands[pos].type && self.printerCommands[pos].parameter ){
					if( self.printerCommands[pos].type == type && typeof(self.printerCommands[pos].parameter) === 'string' ){
						boComandoIgual=true;
					}
				}
			}*/
			if(boComandoIgual){
				self.printerCommands[pos].parameter += parameter;
			} else {
				self.printerCommands.push({
					'type': type,
					'parameter': parameter
				});
			}
		}
	};

	this.printerSpaceCommand = function(){
		self.printerCommands.push({
			'type': self.TEXT_COMMAND,
			'parameter': '\n         ' +
						 '\n         '
		});
	};

	this.printerPrint = function(){
		self.printerCommands.push({ 'type': self.PRINT_COMMAND });
	};

	this.printerStart = function(){
		var arrTemp = Array();
		arrTemp.push({ 'type': self.PRINT_COMMAND });
		self.printerCommands = arrTemp.concat(self.printerCommands);
    };

	this.printerCortarPapel = function(){
        self.printerCommands.push({ 'type': self.CORTAR_CUPOM });
    };

	this.callRecursivePrintCommands = null;

	this.printerInit = function(textSize) {
		return OperatorRepository.findOne().then(function(operatorData) {
			if (!_.isEmpty(self.printerCommands)){
				PrinterClass = _.get(PRINTER_TYPE, operatorData.IDMODEIMPRES);
				if(!PrinterClass) {
					WindowService.log("printerInit: PrinterClass is undefined ");
					return { 'error': false,'message': '' };
				}
				WindowService.log("printerInit: "+(PrinterClass?(PrinterClass.constructor.name):"null")+" - printerCommands: "+JSON.stringify(self.printerCommands));
				return new Promise(function(resolve) {

					window.returnPrintResult = _.bind(PrinterClass.printResult, PrinterClass, resolve, PrinterClass);

					if (PrinterClass){
						if (operatorData.IDMODEIMPRES == '25') {
							PrinterGertec.initPrinter(textSize);
						} else if (operatorData.IDMODEIMPRES == '38') {
							self.printerPrint();
						} else if (operatorData.IDMODEIMPRES == '47') {
							self.printerStart();
							self.printerCortarPapel();
						} else if(operatorData.IDMODEIMPRES == '48') {
							PrinterADX8000.initImpressora();
						}
						self.impressionResolved = null;
						self.callRecursivePrintCommands = _.bind(self.printCommands, self, resolve, PrinterClass);
						self.callRecursivePrintCommands();
					} else {
						return self.invalidPrinterParam();
					}
				}.bind(this));
			} else {
				return self.invalidPrinterCommands();
			}
		}.bind(this)).then(self.endPrint);
	};

	window.returnPrintResult = null;

	this.printCommands = function(impressionResolved, PrinterClass){
		// função recursiva utilizada para chamar as funções de impressão
		self.impressionResolved = impressionResolved;
		var currentPrinterCommand = self.printerCommands.shift();

		new Promise(function(resolve){
			window.returnPrintResult = _.bind(PrinterClass.printResult, PrinterClass, resolve);
			PrinterClass[currentPrinterCommand.type](currentPrinterCommand.parameter);
			self.validaRespostaUltimoComando();
		}.bind(this)).then(function(resolved){
			self.impressionResolved = null;
			if (!resolved.error) {
				if (!_.isEmpty(self.printerCommands)){
					// realiza impressão do próximo comando
					self.callRecursivePrintCommands();
					if(window.ApplicationContext.PaymentController.time>0){
						window.ApplicationContext.PaymentController.time = window.ApplicationContext.PaymentController.time+1;
					}
				} else {
					// impressão realizada com sucesso
					impressionResolved(resolved);
				}
			} else {
				// erro ao realizar impressão
				resolved.message = PRINT_ERROR + resolved.message;
				impressionResolved(resolved);
			}
		}.bind(this));
	};

	this.validaRespostaUltimoComando = function(){
		if (self.printerCommands && self.printerCommands[0]){
			self.contador = (self.contador||0)+1;
			self.printerCommands[0].contador = self.contador;
		}
		if(!self.interval){
			self.contadorinterval = 0;
			self.interval = setInterval(function(){
				if(self.contadorinterval>=12){
					//após 12 segundos verifica se o ultimo comando ainda esta pendente de resposta
					if (self.printerCommands && self.printerCommands[0]){
						if (self.printerCommands[0].contador){
							if (self.printerCommands[0].contador <= self.contador){
								//ficou mais de 10 segundos parado no mesmo comando, assume que a impressão esta com erro e limpa a fila, executa o resolve
								self.endPrint();
								self.impressionResolved({error:true,message:'Timeout de impressão atingido.'});
								WindowService.log("Timeout de impressão atingido 2");
							}
						}
					}
					clearInterval(self.interval);
					self.interval = null;
				} else {
					self.contadorinterval = self.contadorinterval+1;
				}
			},1000);
		} else {
			self.contadorinterval = self.contadorinterval-1;
			//diminui 1 segundo porque enviou mais um comando de impressão
		}
	};

	this.invalidPrinterCommands = function(){
		var result = self.formatResponse();

		result.message = COMMANDS_NOT_FOUND;
		return result;
	};

	this.invalidPrinterParam = function(){
		var result = self.formatResponse();

		result.message = NO_PARAMETERIZED_PRINTER;
		return result;
	};

    this.endPrint = function(result){
		// para qualquer resultado da impressão, se reseta os comandos de impressão e retorna seu resultado
		self.printerCommands = Array();

		return result;
	};

	this.formatResponse = function(){
        return {
            'error': true,
            'message': ''
        };
    };

    PrinterPoynt.formatResponse = self.formatResponse;
    PrinterCieloLio.formatResponse = self.formatResponse;
    PrinterGertec.formatResponse = self.formatResponse;
    PrinterGetnet.formatResponse = self.formatResponse;
    PrinterPagSeguro.formatResponse = self.formatResponse;
	PrinterElgin.formatResponse = self.formatResponse;
	PrinterADX8000.formatResponse = self.formatResponse;
	PrinterStone.formatResponse = self.formatResponse;
	PrinterSmartA8.formatResponse = self.formatResponse;
	PrinterPositivo.formatResponse = self.formatResponse;
	PrinterGPOS720.formatResponse = self.formatResponse;
}

Configuration(function(ContextRegister) {
	ContextRegister.register('PrinterService', PrinterService);
});